#-------------------------------------------------
#
# Project created by QtCreator 2015-03-08T21:51:49
#
#-------------------------------------------------

windows {
    TARGET = CuteSIB
    TARGET_EXT = .exe
    DEFINES += WINDOWS=1
} else {
    TARGET = cutesib
}

VERSION = 0.4.0
TEMPLATE = app

QT += core
QT -= gui

CONFIG += console
CONFIG -= app_bundle

lessThan(QT_GCC_MAJOR_VERSION, 5):lessThan(QT_GCC_MINOR_VERSION, 7) {
    QMAKE_CXXFLAGS += -std=c++0x
    CONFIG += c++0x
} else {
    QMAKE_CXXFLAGS += -std=c++11
    CONFIG += c++11
}

QMAKE_CXXFLAGS += -Wall

release: DESTDIR = $$OUT_PWD
debug:   DESTDIR = $$OUT_PWD

CUTESIB_NAME = CuteSIB
CUTESIB_CONFIG = cutesib.ini
CUTESIB_CONFIG_PATH = .

DEFINES += CUTESIB_VERSION=\\\"$$VERSION\\\"
DEFINES += CUTESIB_NAME=\\\"$$CUTESIB_NAME\\\"
DEFINES += ACCESSPOINTINTERFACE_LIBRARY

CONFIG(release, debug|release):DEFINES += QT_NO_DEBUG_OUTPUT

windows {
    DEFINES += CUTESIB_DLL_EXT=\\\".dll\\\"
} else:mac {
    DEFINES += CUTESIB_DLL_EXT=\\\".dylib\\\"
} else {
    DEFINES += CUTESIB_DLL_EXT=\\\".so\\\"
}


# Install path for unix.
unix {
    target.path = ~/inst/bin
    target.files = $$TARGET
    INSTALLS += target
}

# Now config installed allways in  '/etc' (if the previous config is not exists).
CUTESIB_CONFIG_PATH = ~/inst/bin
!exists($$CUTESIB_CONFIG_PATH/$$CUTESIB_CONFIG) {
   sibconfiguration.files = $$CUTESIB_CONFIG
   sibconfiguration.path = $$CUTESIB_CONFIG_PATH
   INSTALLS += sibconfiguration
}

DEFINES += CUTESIB_CONFIG_PATH=\\\"$$CUTESIB_CONFIG_PATH/$$CUTESIB_CONFIG\\\"

# Paths of dlls and config file to copy.
greaterThan(QT_MAJOR_VERSION, 4) {
    DLL_QT_PATH = $$PWD/../windows/Qt5/
    CONFIG(debug, debug|release):DLL_QT_PATH = $$PWD/../windows/Qt5/*d.*
} else {
    DLL_QT_PATH = $$PWD/../windows/Qt4/
    CONFIG(debug, debug|release):DLL_QT_PATH = $$PWD/../windows/Qt4/*d4.*
}

DLL_PATH = $$PWD/../windows/libs/
DLL_SRC_PATH = $$PWD/../windows/libs/*.dll
CONFIG_SRC_PATH = $$PWD/$$CUTESIB_CONFIG

greaterThan(QT_MAJOR_VERSION, 4) {
    DESTDIR = $$shell_path($$DESTDIR)
    DLL_SRC_PATH = $$shell_path($$DLL_SRC_PATH)
    DLL_QT_PATH = $$shell_path($$DLL_QT_PATH)
    CONFIG_SRC_PATH = $$shell_path($$CONFIG_SRC_PATH)
} else {
    DESTDIR = $$replace(DESTDIR, /, \\)
    DLL_SRC_PATH = $$replace(DLL_SRC_PATH, /, \\)
    DLL_QT_PATH = $$replace(DLL_QT_PATH, /, \\)
    CONFIG_SRC_PATH = $$replace(CONFIG_SRC_PATH, /, \\)
}

# Add target for Makefile to copy config file and dlls to 'build' dir.
!equals(PWD, $${OUT_PWD}) {

windows {
    copydata.commands = $(COPY_FILE) \"$$CONFIG_SRC_PATH\" \"$$DESTDIR\" \
        && $(COPY_FILE) \"$$DLL_SRC_PATH\" \"$$DESTDIR\" \
        && $(COPY_FILE) \"$$DLL_QT_PATH\" \"$$DESTDIR\"
} else {
    copydata.commands = $(COPY_FILE) \"$$CONFIG_SRC_PATH\" \"$$DESTDIR\"
}

    first.depends = $(first) copydata
    export(first.depends)
    export(copydata.commands)
    QMAKE_EXTRA_TARGETS += first copydata
} else {
    QMAKE_EXTRA_TARGETS += first
}


SOURCES += main.cpp \
    sibmanager.cpp \
    accesspointmanager.cpp \
    ssaphandler.cpp \
    ssapmessage.cpp \
    sibconfig.cpp \
    logger.cpp \
    triple.cpp \
    ssapconstants.cpp \
    scheduler.cpp \
    command.cpp \
    commandrequest.cpp \
    commandresponse.cpp \
    triplestore.cpp \
    basicoperationhandler.cpp \
    subscriptionhandler.cpp \
    operationhandler.cpp \
    protocolhandler.cpp \
    subscription.cpp \
    context.cpp \
    sibmodule.cpp \
    tests/stopwatch.cpp \
    sparqlhandler.cpp


HEADERS += \
    sibmanager.h \
    accesspointmanager.h \
    ssaphandler.h \
    ssapmessage.h \
    sibconfig.h \
    siberrors.h \
    logger.h \
    triple.h \
    ssapconstants.h \
    scheduler.h \
    command.h \
    commandrequest.h \
    commandresponse.h \
    triplestore.h \
    basicoperationhandler.h \
    subscriptionhandler.h \
    operationhandler.h \
    protocolhandler.h \
    subscription.h \
    context.h \
    sibmodule.h \
    tests/stopwatch.h \
    sparqlhandler.h

DISTFILES += \
    cutesib.ini


### Libs ###

# Redland for windows.
windows {
    INCLUDEPATH += $$PWD/../windows/include/redland $$PWD/../windows/include/raptor $$PWD/../windows/include/rasqal
    LIBS += -L$$DLL_PATH -lrdf
}

unix {
    #QT_CONFIG -= no-pkg-config for Raspberry Pi
    QT_CONFIG -= no-pkg-config
    CONFIG += link_pkgconfig
    PKGCONFIG += redland rasqal expat
}

win32:CONFIG(release, debug|release): LIBS += -L$$OUT_PWD/../AccessPointInterface/ -lAccessPointInterface
else:win32:CONFIG(debug, debug|release): LIBS += -L$$OUT_PWD/../AccessPointInterface/ -lAccessPointInterface
else:unix: LIBS += -L$$OUT_PWD/../AccessPointInterface/ -lAccessPointInterface

INCLUDEPATH += $$PWD/../AccessPointInterface
DEPENDPATH += $$PWD/../AccessPointInterface

win32-g++:CONFIG(release, debug|release): PRE_TARGETDEPS += $$OUT_PWD/../AccessPointInterface/libAccessPointInterface.a
else:win32-g++:CONFIG(debug, debug|release): PRE_TARGETDEPS += $$OUT_PWD/../AccessPointInterface/libAccessPointInterface.a
else:win32:!win32-g++:CONFIG(release, debug|release): PRE_TARGETDEPS += $$OUT_PWD/../AccessPointInterface/AccessPointInterface.lib
else:win32:!win32-g++:CONFIG(debug, debug|release): PRE_TARGETDEPS += $$OUT_PWD/../AccessPointInterface/AccessPointInterface.lib