#ifndef SPARQLHANDLER_H
#define SPARQLHANDLER_H

#include <QObject>

#include <redland.h>
#include <rasqal.h>
#include "triplestore.h"
#include "commandrequest.h"
#include "commandresponse.h"
#include "operationhandler.h"
#include "context.h"
#include "basicoperationhandler.h"

#define SPARQLHANDLER_ID "OH-SPARQL"

#define SPARQL_SEQ_SEPARATOR ">>"

namespace cutesib {

class SparqlHandler : public OperationHandler
{
    Q_OBJECT
public:
    explicit SparqlHandler(QObject *parent = 0);
    ~SparqlHandler();

    SibError initialize(Context *context);

    CommandResponse* perform(CommandRequest *command);

signals:

public slots:
    void updateState(CommandRequest *command);

private:
    Triplestore* triplestore_;
    librdf_world* RDF_world;
    librdf_model* RDF_model;

    BasicOperationHandler* basicOperationHandler_;
};
}

#endif // SPARQLHANDLER_H
